#include "Flower.h"


Flower::Flower(){
	cout << "implicit constructor" << endl;
	name = NULL;
	price = 0;
}

Flower::Flower(char* name, int p){
	cout << "constructor with param" << endl;
	this->name = new char[strlen(name) + 1];
	strcpy(this->name, name);
	price = p;
}

Flower::Flower(const Flower &f){
	cout << "copy constructor" << endl;
	name = new char[strlen(f.name) + 1];
	strcpy(name, f.name);
	price = f.price;
}

Flower::Flower(char* s){
	cout << "conversion constructor from string" << endl;
	char* aux = strtok(s, ";");
	name = new char[strlen(aux) + 1];
	strcpy(name, aux);
	aux = strtok(NULL, ";");
	price = atoi(aux);
}

//Flower::Flower(Plant &p){
//		cout << "conversion constructor from a plant" << endl;
//		name = new char[strlen(p.getPlantname()) + 1];
//		strcpy(name, p.getPlantname());
//		price = p.getValue();
//	}

	
Flower::~Flower(){
	cout << "destructor of flower " << name << endl;
	if (name){
		delete[] name;
		name =  NULL;
	}
}

Flower& Flower::operator =(const Flower &f){
	if (this != &f){
		if (name)
			delete[] name;
		name = new char[strlen(f.name) + 1];
		strcpy(name, f.name);
		price = f.price;
	}
	return *this;
}
bool Flower::operator==(const Flower &f){
	return (strcmp(name, f.name) == 0);
}
int Flower::getPrice(){
	return price;
}

void Flower::setName(char* n){
	if (name){
		delete[] name;
	}
	name = new char[strlen(n) + 1];
	strcpy(name, n);
}

void Flower::setPrice(int p){
	price = p;
}

char* Flower::toString(){
	char* s = new char[strlen(name) + 1 + 5 + 2];
	char* aux = new char[5];
	strcpy(s, name);
	strcat(s, ";");
	itoa(price, aux, 10);
	strcat(s, aux);
	if (aux){
		delete[] aux;
		aux = NULL;
	}
	strcat(s, "\n");
	return s;
}

