#include <iostream>
using namespace std;

#include "List.h"


void printList(List &l){
	int n = l.getLength();
	for(int i = 0; i < n; i++){
		char* s = l.getElem(i).toString();
		cout << s << " ";
		delete[] s;
	}
	cout << endl;
}

void printListWithIterator(List &l){
	List::iterator lit(&l);
	while (lit.isValid()){
		char* s = lit.getCrtElem().toString(); 
		cout << s << " ";
		delete[] s;
		lit.moveNext();
	}
	cout << endl;
}

void printListWithIteratorWithOverloadedOperators(List &l){
	List::iterator lit(&l);
	while (!lit){
		char* s = lit().toString();
		cout << s << " ";
		delete[] s;
		lit++;
	}
	cout << endl;
}

void printListWithPointerIterator(List &l){
	List::iterator* litPtr = l.getIterator();
	while (litPtr->isValid()){
		char* s = litPtr->getCrtElem().toString();
		cout << s << " ";
		delete[] s;
		litPtr->moveNext();
	}
	cout << endl;
	if (litPtr){
		delete litPtr;
		litPtr = NULL;
	}
}

void printListWithPointerIteratorWithOverloadedOperators(List &l){
	List::iterator* litPtr = l.getIterator();
	while (!(*litPtr)){
		char* s = litPtr->operator()().toString();
		cout << s << " ";		//cout << (*litPtr)() << " ";
		delete[] s;
		litPtr->operator++();						//(*litPtr)++;
	}
	cout << endl;
	if (litPtr){
		delete litPtr;
		litPtr = NULL;
	}
}

int main(){
	List l1;
	Flower f1("rose", 10);
	Flower f2("daisy", 5);
	Flower f3("fresia", 7);
	l1.addInfo(f1);
	l1.addInfo(f2);
	l1.addInfo(f3);
	printListWithIterator(l1);
	printListWithPointerIterator(l1);

	l1.removeElem(f2);
	printListWithIteratorWithOverloadedOperators(l1);
	printListWithPointerIteratorWithOverloadedOperators(l1);
	return 0;
}