#include "List.h"
#include <iostream>
using namespace std;

List::node::node(){
	info = 0;
	next = NULL;
}

List::node::node(TE i, List::node* n){
	info = i;
	next = n;
}

List::node::node(const List::node &n){
	info = n.info;
	next = n.next;
}
List::node::~node(){
	
}
void List::node::setInfo(TE i){
	info = i;
}
void List::node::setNext(List::node* n){
	next = n;
}
TE List::node::getInfo(){
	return info;
}
List::node* List::node::getNext(){
	return next;
}

List::List(copyFunc cpy, compFunc cmp, destroyFunc des){
	this->head = NULL;
	this->copyF = cpy;
	this->compF = cmp;
	this->destroyF = des;
}

List::node* List::copy(){
	List::node* newHead = new node();
	TE el;
	this->copyF(el, head->getInfo());
	newHead->setInfo(el);
	newHead->setNext(NULL);
	List::node* crt = head->getNext();
	if (crt){
		List::node* newCrt = new node();
		this->copyF(el, crt->getInfo());
		newCrt->setInfo(el);
		newCrt->setNext(NULL);
		newHead->setNext(newCrt);
		while (newCrt){
			crt = crt->getNext();
			if(crt){
				List::node *newNode = new node();
				this->copyF(el, crt->getInfo());
				newNode->setInfo(el);
				newNode->setNext(NULL);
				newCrt->setNext(newNode);
			}
			newCrt = newCrt->getNext();
		}
	}
	return newHead;
}

List::List(List& l){
	head = l.copy();
}

void List::clear(){
	List::node* crt;
	while (head){
		crt = head;
		head = head->getNext();
		this->destroyF(crt->getInfo());
		delete crt;
	}
}
List::~List(){
	clear();
}

List& List::operator=(List& l){
	if (this != &l){
		clear();
		this->head = l.copy();
	}
	return *this;
}

void List::addInfo(TE i){
	List::node* n = new node();
	TE el;
	this->copyF(el, i);
	n->setInfo(el);
	n->setNext(head);
	head = n;
}

int List::getLength(){
	int n = 0;
	List::node* crt = head;
	while (crt){
		n++;
		crt = crt->getNext();
	}
	return n;
}

TE List::getElem(int pos){
	int n = 0;
	List::node* crt = head;
	while ((n < pos) && (crt)){
		n++;
		crt = crt->getNext();
	}
	return crt->getInfo();
}

void List::removeElem(TE i){
	if (this->compF(head->getInfo(), i) == 0){
		List::node* aux = head;
		head = head->getNext();
		this->destroyF(aux->getInfo());
		delete aux;
	}
	else{
		List::node* crt = head;
		while ((crt) && (crt->getNext()) && (this->compF(crt->getNext()->getInfo(), i) != 0) )
			crt = crt->getNext();
		if (this->compF(crt->getNext()->getInfo(), i) == 0){
			List::node* aux = crt->getNext();
			crt->setNext(aux->getNext());
			this->destroyF(aux->getInfo());
			delete aux;
		}
	}
}

List::iterator* List::getIterator(){
	return new List::iterator(this);
}


