#include <iostream>
using namespace std;

#include "List.h"
#include "Flower.h"

void copyInt(TE &dest, TE source){
	dest = new int(*(int*)source);
}

int compInt(TE e1, TE e2){
	int val1 = *(int*)e1;
	int val2 = *(int*)e2;
	if (val1 < val2)
		return -1;
	else{
		if (val1 > val2)
			return 1;
		else
			return 0;
	}
}

void destroyInt(TE e){
	if ((int*)e){
		delete (int*) e;
		e = NULL;
	}
}

void printList(List &l){
	int n = l.getLength();
	for(int i = 0; i < n; i++)
		cout << *(int*)l.getElem(i) << " ";
	cout << endl;
}

void printListWithIterator(List &l){
	List::iterator lit(&l);
	while (lit.isValid()){
		cout << *(int*)lit.getCrtElem() << " ";
		lit.moveNext();
	}
	cout << endl;
}

void printListWithIteratorWithOverloadedOperators(List &l){
	List::iterator lit(&l);
	while (!lit){
		cout << *(int*)lit() << " ";
		lit++;
	}
	cout << endl;
}

void printListWithPointerIterator(List &l){
	List::iterator* litPtr = l.getIterator();
	while (litPtr->isValid()){
		cout << *(int*)litPtr->getCrtElem() << " ";
		litPtr->moveNext();
	}
	cout << endl;
	if (litPtr){
		delete litPtr;
		litPtr = NULL;
	}
}

void printListWithPointerIteratorWithOverloadedOperators(List &l){
	List::iterator* litPtr = l.getIterator();
	while (!(*litPtr)){
		cout << *(int*)litPtr->operator()() << " ";		//cout << (*litPtr)() << " ";
		litPtr->operator++();						//(*litPtr)++;
	}
	cout << endl;
	if (litPtr){
		delete litPtr;
		litPtr = NULL;
	}
}

void mainInt(){
	List l1(copyInt, compInt, destroyInt);
	int* e1 = new int(3);
	int* e2 = new int(4);
	int* e3 = new int(9);
	int* e4 = new int(5);
	l1.addInfo(e1);
	l1.addInfo(e2);
	l1.addInfo(e3);
	l1.addInfo(e4);
	printList(l1);

	printListWithIterator(l1);
	printListWithPointerIterator(l1);

	l1.removeElem(e1);
	printListWithIteratorWithOverloadedOperators(l1);
	printListWithPointerIteratorWithOverloadedOperators(l1);
	
	delete e4;
	delete e3;
	delete e2;
	delete e1;
}



void copyFlower(TE &dest, TE source){
	Flower* fp = new Flower();
	fp->setName(((Flower*)source)->getName());
	fp->setPrice(((Flower*)source)->getPrice());
	dest = fp;
}

int compFlower(TE e1, TE e2){
	Flower f1 = *(Flower*)e1;
	Flower f2 = *(Flower*)e2;
	return strcmp(f1.getName(), f2.getName());
}

void destroyFlower(TE e){
	Flower* fp = (Flower*)e;
	if (fp){
		delete fp;
		fp = NULL;
	}
}

void printListFlowers(List &l){
	int n = l.getLength();
	for(int i = 0; i < n; i++)
		cout << ((Flower*)l.getElem(i))->getName() << " " << ((Flower*)l.getElem(i))->getPrice() << ";";
	cout << endl;
}

void mainFlower(){
	List l1(copyFlower, compFlower, destroyFlower);
	Flower* fp1 = new Flower();
	fp1->setName("rose");
	fp1->setPrice(10);
	Flower* fp2 = new Flower();
	fp2->setName("tulip");
	fp2->setPrice(20);
	Flower* fp3 = new Flower();
	fp3->setName("daisy");
	fp3->setPrice(30);
	l1.addInfo(fp1);
	l1.addInfo(fp2);
	l1.addInfo(fp3);
	printListFlowers(l1);

	l1.removeElem(fp2);
	printListFlowers(l1);
	delete fp3;
	delete fp2;
	delete fp1;
}

int main(){
	mainInt();
	mainFlower();
}
