#include "List.h"

List::node::node(){
		//this is a pointer to an object of type List::node
	this->info = 0;
	this->next = NULL;
}

List::node::node(TE i, List::node* n){
		//this is a pointer to an object of type List::node
	this->info = i;
	this->next = n;
}

List::node::node(const List::node &n){
		//this is a pointer to an object of type List::node
	this->info = n.info;
	this->next = n.next;
}

List::node::~node(){
}

List::node& List::node::operator=(const List::node &n){
		//this is a pointer to an object of type List::node
	if (this != &n){
		this->info = n.info;
		this->next = n.next;
	}
	return *this;
}

void List::node::setInfo(TE i){
			//this is a pointer to an object of type List::node
	this->info = i;
}

void List::node::setNext(List::node* n){
		//this is a pointer to an object of type List::node
	this->next = n;
}

TE List::node::getInfo(){
		//this is a pointer to an object of type List::node
	return this->info;
}

List::node* List::node::getNext(){
		//this is a pointer to an object of type List::node
	return this->next;
}


List::List(){
		//this is a pointer to an object of type List
	this->head = NULL;
}

List::node* List::copy(){
	List::node* newHead = new List::node(head->getInfo(), NULL);
	List::node* crt = head->getNext();
	if (crt){
		List::node* newCrt = new List::node(crt->getInfo(), NULL);
		newHead->setNext(newCrt);
		while (newCrt){
			crt = crt->getNext();
			if(crt){
				List::node *newnode = new List::node(crt->getInfo(), NULL);
				newCrt->setNext(newnode);
			}
			newCrt = newCrt->getNext();
		}
	}
	return newHead;
}

List::List(List& l){
	head = l.copy();
}

void List::clear(){
	List::node* crt;
	while (head){
		crt = head;
		head = head->getNext();
		delete crt;
	}
}
List::~List(){
	clear();
}

List& List::operator=(List& l){
	if (this != &l){
		clear();
		this->head = l.copy();
	}
	return *this;
}

void List::addInfo(TE i){
	List::node* n = new List::node(i, head);
	head = n;
}

int List::getLength(){
	int n = 0;
	List::node* crt = head;
	while (crt){
		n++;
		crt = crt->getNext();
	}
	return n;
}

TE List::getElem(int pos){
	int n = 0;
	List::node* crt = head;
	while ((n < pos) && (crt)){
		n++;
		crt = crt->getNext();
	}
	if (crt)
		return crt->getInfo();
	else
		return 0;
}

void List::removeElem(TE i){
	if (head->getInfo() == i){
		List::node* aux = head;
		head = head->getNext();
		delete aux;
	}
	else{
		List::node* crt = head;
		while ((crt) && (crt->getNext()) && (crt->getNext()->getInfo() != i) )
			crt = crt->getNext();
		if (crt->getNext()->getInfo() == i){
			List::node* aux = crt->getNext();
			crt->setNext(aux->getNext());
			delete aux;
		}
	}
}