#include <iostream>
using namespace std;

#include "List.h"


void printList(List &l){
	int n = l.getLength();
	for(int i = 0; i < n; i++)
		cout << l.getElem(i) << " ";
	cout << endl;
}

void printListWithIterator(List &l){
	List::iterator lit(&l);
	while (lit.isValid()){
		cout << lit.getCrtElem() << " ";
		lit.moveNext();
	}
	cout << endl;
}

void printListWithIteratorWithOverloadedOperators(List &l){
	List::iterator lit(&l);
	while (!lit){
		cout << lit() << " ";
		lit++;
	}
	cout << endl;
}

void printListWithPointerIterator(List &l){
	List::iterator* litPtr = l.getIterator();
	while (litPtr->isValid()){
		cout << litPtr->getCrtElem() << " ";
		litPtr->moveNext();
	}
	cout << endl;
	if (litPtr){
		delete litPtr;
		litPtr = NULL;
	}
}

void printListWithPointerIteratorWithOverloadedOperators(List &l){
	List::iterator* litPtr = l.getIterator();
	while (!(*litPtr)){
		cout << litPtr->operator()() << " ";		//cout << (*litPtr)() << " ";
		litPtr->operator++();						//(*litPtr)++;
	}
	cout << endl;
	if (litPtr){
		delete litPtr;
		litPtr = NULL;
	}
}

int main(){
	List l1;
	l1.addInfo(3);
	l1.addInfo(4);
	l1.addInfo(9);
	l1.addInfo(5);
	printListWithIterator(l1);
	//printListWithPointerIterator(l1);

	l1.removeElem(3);
	//printListWithIteratorWithOverloadedOperators(l1);
	printListWithPointerIteratorWithOverloadedOperators(l1);
	return 0;
}