#include "Manager.h"
#include <string>

/*
Descr: create a manager 
In: -
Out: an empty instance of Manager
*/
Manager::Manager(){
	name = NULL;
}

//Descr: create a copy of a manager 
//In: a manager m
//Out: a new instance of Manager = a copy of m
Manager::Manager(const Manager &m){
	name = new char[strlen(m.name) + 1];
	strcpy_s(name, strlen(m.name) + 1, m.name);
}

//Descr: distroy a manager 
//In: a manager 
//Out: - (destructor)
Manager::~Manager(){
	if (name){
		delete[] name;
		name = NULL;
	}
}

//Descr: create a new Manager (equal to a given manager m)
//In: a manager (m)
//Out: a new manager (equal to m)
Manager& Manager::operator=(const Manager &m){
	if (this != &m){
		if (name)
			delete[] name;
		name = new char[strlen(m.name) + 1];
		strcpy_s(name, strlen(m.name) + 1, m.name);
	}
	return *this;
}

//Descr: change the name of a manager 
//In: a manager and a name
//Out: the manager with changed name
void Manager::setName(char* n){
	if (name)
		delete[] name;
	name = new char[strlen(n) + 1];
	strcpy_s(name, strlen(n) + 1, n);

}

//Descr: access the name of a manager 
//In: a manager
//Out: the name of manager
char* Manager::getName(){
	return name;
}